MARTe2-core - User story #142

MARTe-EX-F-1.1.15: The framework shall offer portable support for basic console operations.
03.06.2015 11:40 - Riccardo Vitelli

Status: Closed Start date:
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 16.00 hours
Target version: 0.2 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Implement requirement MARTe-EX-F-1.1.15 based on the original MARTe implementation.

Note: Basic is intended as with no streaming support. Expected functionality (as minimum) is I/O to/from stdin/stdout. This
implementation should be portable and delegated to the different operating systems console implementation.

Source code files modified

Source/Core/L0Portability/BasicConsole.cpp
Source/Core/L0Portability/BasicConsole.h
Source/Core/L0Portability/OperatingSystem/Linux/BasicConsoleOS.cpp
Source/Core/L0Portability/OperatingSystem/Windows/BasicConsoleOS.cpp
Test/Core/LOPortability/BasicConsoleTest.cpp
Test/Core/LOPortability/BasicConsoleTest.h
Test/GTest/BasicConsoleGTest.cpp

Architecture & design review
Date of the review: 23/06/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support function and does
not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review

Date of the review: 01/07/2015
Person who did the review: lvan Herrero
Result of review: PASS

List of non-conformities: N/A

Unit test review

Date of the review: 24/07/2015

Person who did the review: lvan Herrero
Result of coverage tests review: PASS
Result of functional tests review: PASS
Result of review: PASS

List of non-conformities:

Coverage note: Some error paths not exercised

The following methods of BasicConsole do not have an explicit test, because the answer is different according to the target operating
system:

¢ bool ColourSupported()

¢ bool ConsoleBufferSupported()
¢ bool CursorPositionSupported()
¢ bool TitleBarSupported()

¢ bool WindowSizeSupported()

¢ bool TimeoutSupported()

The following methods of BasicConsole are not tested because they are not implemented in Linux:

¢ ErrorType BasicConsole::ShowBuffer();

¢ ErrorType BasicConsole::SetColour(const Colours &foregroundColour, const Colours &backgroundColour);

e ErrorType BasicConsole::SetTitleBar(const char8 * const title);

ErrorType BasicConsole::GetTitleBar(char8 * const title, const uint32 &size) const;

ErrorType BasicConsole::SetCursorPosition(const uint32 &column, const uint32 &row);

ErrorType BasicConsole::GetCursorPosition(uint32 &column, uint32 &row) const;

ErrorType BasicConsole::SetWindowSize(const uint32 &numberOfColumns, const uint32 &numberOfRows);

ErrorType BasicConsole::GetWindowSize(uint32 &numberOfColumns, uint32 &nhumberOfRows) const;

ErrorType BasicConsole::PlotChar(const char8 &c, const Colours &foregroundColour, const Colours &backgroundColour, const
uint32 &column, const uint32 &row);

Associated revisions

Revision 65eef75¢c - 22.06.2015 14:04 - Giuseppe Ferro

Added BasicConsole implementation
#142

Revision 98bcb659 - 23.06.2015 11:55 - Giuseppe Ferro

Fixed warnings.
#142

Revision 44118403 - 23.06.2015 16:54 - Giuseppe Ferro

Fixed issues accordingly with revision.
#142

Revision fc4753aa - 26.06.2015 11:54 - Giuseppe Ferro

Corrected code accordingly with revision.
#142

Revision ¢2568369 - 17.07.2015 14:04 - Llorenc Capella

US #142 Basic console tests added and BasicConsole::Write() corrected.

List of changes: * When size > real string size the Write() returns a wrong size

written. It was corrected.  * Makefile.inc in the GTest folter modified to include the ConsoleGTest * Rename TestOpen to TestOpenModeDefault
* TestOpenModeCreateNewBuffer added.  * TestOpenPerformCharacterinput added. * TestOpenDisableControlBreak added.  *
TestOpenEnablePaging added.  * TestGetMode added. * TestClose added. * Rename TestWrite to TestWriteCheckReturn.  *

TestWriteNullString added.  * TestWriteExactSize added.  * TestWriteSmallSize added.  * TestWriteLargeSize added. * TestWirteEndColumn
added.

Revision 973b449b - 17.07.2015 17:58 - Llorenc Capella
US #142 BasicConsoleOS bug correction

Bug related with currentColumn corrected. Now when the currentChar="n'
the currentColumn is reseted (set to 0).

Revision d8a20764 - 23.07.2015 12:40 - Giuseppe Ferro

BasicConsole tests implementation.
#142

Revision c4cb5ff9 - 24.07.2015 17:02 - lvan Herrero

#142 - Minor formatting corrections (following template rules)
Revision efd10a0e - 24.07.2015 17:55 - Giuseppe Ferro
Added TestConstructor and TestTimeoutRead to BasicConsoleTest.

#142

History

#1 - 03.06.2015 14:55 - André Neto

- Subject changed from MARTe-EX-F-1.1.15: The framework shall have basic and portable support for console operations. to MARTe-EX-F-1.1.15:
The framework shall offer portable support for basic console operations.

- Description updated

#2 - 12.06.2015 10:32 - Riccardo Vitelli

- Status changed from New to Arch: Rev

#3 - 12.06.2015 11:15 - Riccardo Vitelli

- Assignee set to André Neto

#4 - 12.06.2015 18:29 - André Neto

- Description updated

#5 - 18.06.2015 12:42 - Giuseppe Ferro
- Status changed from Arch: Rev to Code: Impl

#6 - 18.06.2015 12:42 - Giuseppe Ferro

- Assignee changed from André Neto to Giuseppe Ferro

#7 - 22.06.2015 17:31 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#8 - 22.06.2015 17:31 - Riccardo Vitelli

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#9 - 23.06.2015 15:37 - Ivan Herrero

- Description updated

Code and documentation review made on revision b99ba9f. Code and documentation corrections pending.

#10 - 23.06.2015 18:04 - André Neto
- Status changed from Code: Rev to Code: Impl

#11 - 23.06.2015 18:04 - André Neto

- Assignee changed from Ivan Herrero to Giuseppe Ferro

#12 - 25.06.2015 17:18 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#13 - 25.06.2015 17:20 - Riccardo Vitelli
- Assignee deleted (Giuseppe Ferro)
#14 - 25.06.2015 19:06 - lvan Herrero

- Description updated

Source/Core/LOPortability/OperatingSystem/Linux/BasicConsoleOS.h correction not completed, yet.
Source/Core/L0OPortability/OperatingSystem/Windows/BasicConsoleOS.h correction not completed, yet.

#15 - 25.06.2015 19:06 - lvan Herrero
- Status changed from Code: Rev to Code: Impl

#16 - 26.06.2015 11:44 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#17 - 29.06.2015 09:52 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#18 - 29.06.2015 09:53 - Riccardo Vitelli
- Assignee deleted (Giuseppe Ferro)

#19 - 01.07.2015 11:20 - Ilvan Herrero
- Description updated

- Assignee set to Ivan Herrero

Code and documentation review made on revision 8e15315 [PASS].

#20 - 01.07.2015 13:07 - Riccardo Vitelli
- Status changed from Code: Rev to Unit: Impl

#21 - 01.07.2015 13:07 - Riccardo Vitelli

- Assignee deleted (lvan Herrero)

#22 - 02.07.2015 18:06 - Riccardo Vitelli

- Target version changed from 0.1 to 0.2

#23 - 16.07.2015 09:52 - Llorenc Capella

- Assignee set to Llorenc Capella

#24 - 20.07.2015 11:01 - Llorenc Capella
- Status changed from Unit: Impl to Unit: Rev

#25 - 20.07.2015 11:03 - Llorenc Capella
- Assignee deleted (Llorenc Capella)

TestPerfChar() does not work well on the eclipse console (because it needs an enter), but does work on the Linux console.

#26 - 22.07.2015 14:57 - Llorenc Capella
- Status changed from Unit: Rev to Unit: Impl

#27 - 22.07.2015 15:09 - Llorenc Capella

- Assignee set to Giuseppe Ferro

#28 - 23.07.2015 15:15 - Giuseppe Ferro
- Status changed from Unit: Impl to Unit: Rev

#29 - 23.07.2015 15:16 - Giuseppe Ferro
- Assignee deleted (Giuseppe Ferro)

Unit Tests done.
#30 - 24.07.2015 12:16 - lvan Herrero

- Assignee set to Ivan Herrero

#31 - 24.07.2015 17:06 - Ivan Herrero
- Description updated
- Status changed from Unit: Rev to Unit: Impl

- Assignee deleted (Ilvan Herrero)

Unit test review made on revision c4cb5ff.

#32 - 24.07.2015 17:23 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#33 - 24.07.2015 17:56 - Giuseppe Ferro
- Assignee deleted (Giuseppe Ferro)

Unit Implementation Done: efd10a0

#34 - 24.07.2015 17:57 - Giuseppe Ferro
- Status changed from Unit: Impl to Unit: Rev

#35 - 24.07.2015 19:10 - lvan Herrero

- Assignee set to Ivan Herrero

#36 - 24.07.2015 19:18 - Ivan Herrero
- Description updated
- Status changed from Unit: Rev to Closed

- Assignee deleted (lvan Herrero)

Unit test review made on revision cb388cb.
